%define name	socks5
%define version	1.0r11
%define rel	8

%define release	%mkrel %rel
%define distsuffix plf

Summary:	SOCKS 5.0 Server Daemon
Name:		%{name}
Version:	%{version}
Release:	%{release}
Group:		System/Servers
License:	Freely Distributable
URL:		http://www.socks.permeo.com/
Source0:	%{name}-v%{version}.tar.bz2
Source1:	socks5.init
Source2:	unsocks
Patch0:		socks5-v1.0r11.patch1.txt.bz2
Patch1:		socks5-vararg.patch.bz2
Patch2:		socks5-v1.0r11-ifaaddr.patch.bz2
Patch3:		socks5-v1.0r11-lib64.patch.bz2
BuildRequires:	ncurses-devel autoconf2.1
BuildRoot:	%{_tmppath}/%{name}-root
Prereq:		rpm-helper

%package clients
Summary:	Network applications written to use NWSL SOCKS 5.0
Group:		System/Servers

%package -n runsocks
Summary:	DLL and utility to socksify existing applications
Group:		Development/Other

%package devel
Summary:	SOCKS 5.0 header file and library
Group:		Development/Other
Conflicts:	dante-devel

%description
This is NWSL (previously CSTC) version 5.0 of SOCKS, a package that
allows Unix hosts behind a firewall to gain full access to the
internet without requiring direct IP reachability.  It does require a
SOCKS server program being run on a host that can communicate directly
to hosts behind the firewall as well as hosts on the Internet at
large.  It is based on the original SOCKS written by David Koblas
<koblas@netcom.com> and the work of the AFT working group of the IETF.
This package is in PLF because of its non-free license.

%description clients
Client programs such as ping, traceroute, ftp, finger, whois, archie, and 
telnet that use SOCKS 5.0.  Also includes a dynamic link library and script 
that allows you to "socksify" programs that don't normally use SOCKS.
This package is in PLF because of its non-free license.

%description devel
This is the header file and library required to develop for NWSL 
(previously CSTC) version 5.0 of SOCKS.
This package is in PLF because of its non-free license.

%description -n runsocks
Dynamic link library and utility that allows you to "socksify"
programs that don't normally use SOCKS.
This package is in PLF because of its non-free license.

%prep 
%setup -q -n %{name}-v%{version} 
%patch0 -p0
%patch1 -p1
%patch2 -p1
%patch3 -p1
autoconf

%build
%serverbuild
# Ideally, we'd just build the threaded version on all platforms, but
# then it wants to use the signal SIGUNUSED, and this isn't available
# on sparc.
%ifarch sparc
    %configure \
    --with-srvpidfile=/var/run/socks5.pid \
    --with-libconffile=%{_sysconfdir}/libsocks5.conf \
    --with-srvconffile=%{_sysconfdir}/socks5.conf \
    --with-syslog-facility
    make # issue with parallel build
%else
    %configure \
	--with-srvpidfile=/var/run/socks5.pid \
	--with-libconffile=%{_sysconfdir}/libsocks5.conf \
	--with-srvconffile=%{_sysconfdir}/socks5.conf \
	--with-syslog-facility \
	--with-threads
    make # issue with parallel build
%endif

%install
rm -rf $RPM_BUILD_ROOT
sourcedir=`pwd`

# "make install" creates all the necessary directories
%makeinstall
cd $RPM_BUILD_ROOT%{_bindir}
# We prefer the s5 prefix; it conflicts less
mv rarchie s5archie
mv rfinger s5finger
mv rftp s5ftp
mv rping s5ping
mv rtelnet s5telnet
mv rtraceroute s5traceroute
mv rwhois s5whois
# We restore the permissions on the clients in the %files section; 
# if they're 111 here then cpio won't be able to read them to build 
# the rpm and strip won't touch them.
chmod 711 s5*
# Move the daemon to the sbin directory
mkdir ../sbin
mv socks5 stopsocks ../sbin
# Install the init script
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install -m 755 %{SOURCE1} \
    $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/socks5
# Default config file for the clients; no default for the daemon
echo "socks5 - - - - -" > $RPM_BUILD_ROOT%{_sysconfdir}/libsocks5.conf

# Install the 'unsocks' utility
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}/unsocks

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc ChangeLog Copyright README doc examples patches
%doc %{_mandir}/man1/stopsocks.*
%doc %{_mandir}/man1/socks5.*
%doc %{_mandir}/man5/socks5.conf.*
%doc %{_mandir}/man5/socks5.passwd.*
%{_sbindir}/stopsocks
%{_sbindir}/socks5
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/rc.d/init.d/socks5

%files clients
%defattr(-,root,root)
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/libsocks5.conf
%doc %{_mandir}/man1/socks5_clients.*
%attr(755,root,root) %{_bindir}/s5*

%files -n runsocks
%defattr(-,root,root)
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/libsocks5.conf
%doc %{_mandir}/man1/runsocks.*
%doc %{_mandir}/man5/libsocks5.conf.*
%{_libdir}/libsocks5_sh.so
%{_bindir}/runsocks
%{_bindir}/unsocks

%files devel
%defattr(-,root,root)
%doc test
%{_libdir}/libsocks5.a
%{_includedir}/socks.h

%post
%_post_service socks5

%preun
%_preun_service socks5

%changelog
* Thu Oct 20 2005 Anssi Hannula <anssi@zarb.org> 1.0r11-8plf
- fix libdir on x86_64 (patch3)
- mkrel
- use make instead of %%make

* Thu Jul 21 2005 Pascal Terjan <pterjan@zarb.org> 1.0r11-7plf
- -devel conflicts dante-devel (bug 39)
- Really strip
- Fix summary-ending-with-dot
- Quiet %%setup
- Add reason-for-plf

* Mon Jan 12 2004 Pascal Terjan <CMoi@tuxfamily.org> 1.0r11-6plf
- Apply the patch (aka I sux)
- Update URL (Luca Berra)
- Prereq rpm-helper

* Sun Jan 11 2004 Pascal Terjan <CMoi@tuxfamily.org> 1.0r11-5plf
- Patch from Luca Berra <bluca@vodka.it> avoiding segfault from apps using
  socks5

* Fri Jan  2 2004 Mircea Ciocan <mircea@smartpost.ro> 1.0r11-4plf
- Rename for differentiantion
- Fix compile with varargs using stdarg.h for new gcc3

* Thu May  9 2002 Stefan van der Eijk <stefan@eijk.nu> 1.0r11-3plf
- BuildRequires

* Thu Apr 25 2002 David Walluck <david@anti-microsoft.org> 1.0r11-2plf 
- cleanup

* Mon Apr 22 2002 David Walluck <david@anti-microsoft.org> 1.0r11-1plf
- release
